<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html><head><meta http-equiv="Content-Type" content="text/html;charset=iso-8859-1">
<title>WarpTree: src/modelnode.h Source File</title>
<link href="doxygen.css" rel="stylesheet" type="text/css">
<link href="tabs.css" rel="stylesheet" type="text/css">
</head><body>
<!-- Generated by Doxygen 1.5.0 -->
<div class="tabs">
  <ul>
    <li><a href="index.html"><span>Main&nbsp;Page</span></a></li>
    <li><a href="annotated.html"><span>Classes</span></a></li>
    <li id="current"><a href="files.html"><span>Files</span></a></li>
  </ul></div>
<h1>src/modelnode.h</h1><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/* This file is part of WarpTree</span>
<a name="l00002"></a>00002 <span class="comment"> *</span>
<a name="l00003"></a>00003 <span class="comment"> * Copyright (C) 2007 Jos van den Oever &lt;jos@vandenoever.info&gt;</span>
<a name="l00004"></a>00004 <span class="comment"> *</span>
<a name="l00005"></a>00005 <span class="comment"> * This library is free software; you can redistribute it and/or</span>
<a name="l00006"></a>00006 <span class="comment"> * modify it under the terms of the GNU Library General Public</span>
<a name="l00007"></a>00007 <span class="comment"> * License as published by the Free Software Foundation; either</span>
<a name="l00008"></a>00008 <span class="comment"> * version 2 of the License, or (at your option) any later version.</span>
<a name="l00009"></a>00009 <span class="comment"> *</span>
<a name="l00010"></a>00010 <span class="comment"> * This library is distributed in the hope that it will be useful,</span>
<a name="l00011"></a>00011 <span class="comment"> * but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00012"></a>00012 <span class="comment"> * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00013"></a>00013 <span class="comment"> * Library General Public License for more details.</span>
<a name="l00014"></a>00014 <span class="comment"> *</span>
<a name="l00015"></a>00015 <span class="comment"> * You should have received a copy of the GNU Library General Public License</span>
<a name="l00016"></a>00016 <span class="comment"> * along with this library; see the file COPYING.LIB.  If not, write to</span>
<a name="l00017"></a>00017 <span class="comment"> * the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,</span>
<a name="l00018"></a>00018 <span class="comment"> * Boston, MA 02110-1301, USA.</span>
<a name="l00019"></a>00019 <span class="comment"> */</span>
<a name="l00020"></a>00020 <span class="comment">// parts of code for layout was adapted from HyperTree published under</span>
<a name="l00021"></a>00021 <span class="comment">// MIT License 2001 www.bouthier.net</span>
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef MODELNODE_H</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define MODELNODE_H</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="preprocessor">#include "warptreeview.h"</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include "warpcoord.h"</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &lt;QtCore/QThread&gt;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &lt;QtGui/QIcon&gt;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &lt;QtCore/QModelIndex&gt;</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &lt;QtCore/QLine&gt;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &lt;QtCore/QVector&gt;</span>
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 <span class="keyword">class </span>ParentModelNode;
<a name="l00034"></a>00034 <span class="keyword">class </span>ModelNode {
<a name="l00035"></a>00035 <span class="keyword">public</span>:
<a name="l00036"></a>00036     <span class="comment">// the public part of the node (QModelIndex, QRect and depth)</span>
<a name="l00037"></a>00037     <a class="code" href="classWarpTreeNode.html">WarpTreeNode</a> node;
<a name="l00038"></a>00038     <span class="comment">// the coordinate as originally layed out</span>
<a name="l00039"></a>00039     WarpCoord original;
<a name="l00040"></a>00040     <span class="comment">// the original coordinate translated with respect to the views origin</span>
<a name="l00041"></a>00041     WarpCoord translated;
<a name="l00042"></a>00042     <span class="comment">// the parent of the node</span>
<a name="l00043"></a>00043     ParentModelNode* parent;
<a name="l00044"></a>00044     <span class="comment">// the weight of the node. this depends on the number of children</span>
<a name="l00045"></a>00045     <span class="keywordtype">float</span> weight;
<a name="l00046"></a>00046     <span class="comment">// whether to show the line connecting this node to its parent</span>
<a name="l00047"></a>00047     <span class="keywordtype">bool</span> showLine;
<a name="l00048"></a>00048     <span class="comment">// whether to draw the label</span>
<a name="l00049"></a>00049     <span class="keywordtype">bool</span> showText;
<a name="l00050"></a>00050 
<a name="l00051"></a>00051     ModelNode(<span class="keywordtype">int</span> d) :node(d), parent(0), weight(1) {}
<a name="l00052"></a>00052     <span class="keyword">virtual</span> ~ModelNode() {}
<a name="l00053"></a>00053     <span class="comment">// lay out a node with respect to its parent</span>
<a name="l00054"></a>00054     <span class="keyword">virtual</span> <span class="keywordtype">void</span> layout(<span class="keywordtype">float</span> angle, <span class="keywordtype">float</span> width, <span class="keywordtype">float</span> length);
<a name="l00055"></a>00055     <span class="comment">// update the screen coordinates from the translated coordinates</span>
<a name="l00056"></a>00056     <span class="keywordtype">void</span> updateScreenCoords(<span class="keywordtype">float</span> halfw, <span class="keywordtype">float</span> halfh);
<a name="l00057"></a>00057     <span class="comment">// move the node with respect to the views origin and zoomfactor</span>
<a name="l00058"></a>00058     <span class="keywordtype">void</span> translate(<span class="keyword">const</span> WarpCoord&amp; m, <span class="keywordtype">float</span> zoomFactor);
<a name="l00059"></a>00059 };
<a name="l00060"></a>00060 <span class="keyword">class </span>ParentModelNode : <span class="keyword">public</span> ModelNode {
<a name="l00061"></a>00061 <span class="keyword">public</span>:
<a name="l00062"></a>00062     <span class="comment">// the children of this node</span>
<a name="l00063"></a>00063     QVector&lt;ModelNode*&gt; children;
<a name="l00064"></a>00064     <span class="comment">// the global weight of this node</span>
<a name="l00065"></a>00065     <span class="keywordtype">float</span> globalWeight;
<a name="l00066"></a>00066     <span class="comment">// the number of children in this node</span>
<a name="l00067"></a>00067     <span class="keywordtype">int</span> count;
<a name="l00068"></a>00068     <span class="comment">// the width (angle) of this node</span>
<a name="l00069"></a>00069     <span class="keywordtype">float</span> width;
<a name="l00070"></a>00070     <span class="comment">// the length of the connection of this node to its parent</span>
<a name="l00071"></a>00071     <span class="keywordtype">float</span> length;
<a name="l00072"></a>00072     <span class="comment">// the angle of this node</span>
<a name="l00073"></a>00073     <span class="keywordtype">float</span> angle;
<a name="l00074"></a>00074     <span class="comment">// have the children of this node been loaded?</span>
<a name="l00075"></a>00075     <span class="keywordtype">bool</span> complete;
<a name="l00076"></a>00076 
<a name="l00077"></a>00077     ParentModelNode(<span class="keywordtype">int</span> d) :ModelNode(d), globalWeight(0), complete(false) {}
<a name="l00078"></a>00078     <span class="comment">// overloaded function for laying out this node</span>
<a name="l00079"></a>00079     <span class="keywordtype">void</span> layout(<span class="keywordtype">float</span> angle, <span class="keywordtype">float</span> width, <span class="keywordtype">float</span> length);
<a name="l00080"></a>00080 };
<a name="l00081"></a>00081 
<a name="l00082"></a>00082 <span class="preprocessor">#endif</span>
</pre></div><hr size="1"><address style="align: right;"><small>Generated on Sat Jun 2 19:18:06 2007 for WarpTree by&nbsp;
<a href="http://www.doxygen.org/index.html">
<img src="doxygen.png" alt="doxygen" align="middle" border="0"></a> 1.5.0 </small></address>
</body>
</html>
